-------------------------------------------------------------------------------
-- Locals                                                                    --
-------------------------------------------------------------------------------

local L = AceLibrary("AceLocale-2.2"):new("BanzaiAlert")

local banzai = AceLibrary("Banzai-1.1")

local playerName = nil
local lastAggroAlert = nil
local isFlashing = nil
--local lastUnitTable = nil

local sounds = {
	babe = "Interface\\AddOns\\BanzaiAlert\\sounds\\babe.wav",
	zenham = "Interface\\AddOns\\BanzaiAlert\\sounds\\zenham.wav",
	BellTollAlliance = "Sound\\Doodad\\BellTollAlliance.wav",
	bell = "AuctionWindowClose",
}

-------------------------------------------------------------------------------
-- Localization                                                              --
-------------------------------------------------------------------------------

L:RegisterTranslations("enUS", function() return {
	["Sound alert"] = true,
	["Plays a sound alert when you get aggro."] = true,
	["Text alert"] = true,
	["Displays a message on the screen when you get aggro."] = true,
	["Only in group"] = true,
	["Only alert for aggro when you are grouped."] = true,
	["Health frame flash"] = true,
	["Flash the health frame when you get aggro."] = true,
	["Lost aggro"] = true,
	["Alerts you when you lose aggro."] = true,

	["None"] = true,

	["Aggro from %s!"] = true,
	["Lost aggro!"] = true,

	-- oRA2 module
	["aggroalert"] = true,
	["Participant/AggroAlert"] = true,
	["aggro"] = true,
	["Aggro alert"] = true,
	["Options for aggro notifications."] = true,
	
	["Display"] = true,
	["Set where messages are displayed."] = true,
	
	["Default Frame"] = "Default",
	["BigWigs frame"] = "BigWigs",
	["Mik's Scrolling Battle Text"] = "MSBT",
	["Scrolling Combat Text"] = "SCT",
} end)

L:RegisterTranslations("koKR", function() return {
	["Sound alert"] = "경고 효과음",
	["Plays a sound alert when you get aggro."] = "어그로 획득시 경고 효과음을 재생합니다.",
	["Text alert"] = "경고 텍스트",
	["Displays a message on the screen when you get aggro."] = "어그로 획득시 화면에 메세지를 표시합니다.",
	["Only in group"] = "파티만 사용",
	["Only alert for aggro when you are grouped."] = "파티에 속해 있을 때에만 경고를 사용합니다.",
	["Health frame flash"] = "화면 번쩍임",
	["Flash the health frame when you get aggro."] = "어그로 획득시 생명력 프레임(화면 외곽)을 번쩍입니다.",
	["Lost aggro"] = "어그로 손실",
	["Alerts you when you lose aggro."] = "어그로 손실시 알립니다.",

	["Aggro from %s!"] = "%s의 어그로 획득!",
	["Lost aggro!"] = "어그로 손실!",

	-- oRA2 module
	["aggroalert"] = "어그로경고",
	["Participant/AggroAlert"] = "참여자/어그로 경고",
	["aggro"] = "어그로",
	["Aggro alert"] = "어그로 경고",
	["Options for aggro notifications."] = "어그로 경고에 대해 설정합니다.",
	
	["Display"] = "디스플레이",
	["Set where messages are displayed."] = "메세지가 표시되는 곳을 설정합니다.",

	["Default Frame"] = "기본",
	["BigWigs frame"] = "BigWigs",
	["Mik's Scrolling Battle Text"] = "MSBT",
	["Scrolling Combat Text"] = "SCT",
} end)

L:RegisterTranslations("zhTW", function() return {
	["Sound alert"] = "聲音警告",
	["Plays a sound alert when you get aggro."] = "當你得到Aggro時發出聲音警告",
	["Text alert"] = "文字警告",
	["Displays a message on the screen when you get aggro."] = "當你得到Aggro時在螢幕顯示文字警告",
	["Only in group"] = "隊伍模式",
	["Only alert for aggro when you are grouped."] = "只有當你在隊伍裡時發出Aggro警告",
	["Health frame flash"] = "全螢幕閃光警告",
	["Flash the health frame when you get aggro."] = "在你得到Aggro後發出全螢幕閃光警告",
	["Lost aggro"] = "失去Aggro",
	["Alerts you when you lose aggro."] = "當你失去Aggro時發出警告",

	["Aggro from %s!"] = "得到 %s 的 Aggro！",
	["Lost aggro!"] = "失去 Aggro！",

	-- oRA2 module
	["aggroalert"] = "Aggro警報",
	["Participant/AggroAlert"] = "Participant/AggroAlert",
	["aggro"] = "aggro",
	["Aggro alert"] = "Aggro警報",
	["Options for aggro notifications."] = "Aggro 通知選項",
	
	["Display"] = "顯示",
	["Set where messages are displayed."] = "設定訊息將會顯示在哪裡",
	
	["Default Frame"] = "預設",
	["BigWigs frame"] = "BigWigs",
	["Mik's Scrolling Battle Text"] = "MSBT",
	["Scrolling Combat Text"] = "SCT",
} end)

L:RegisterTranslations("esES", function() return {
	["Sound alert"] = "Alerta sonora",
	["Plays a sound alert when you get aggro."] = "Reproduce un sonido de alerta cuando tienes aggro.",
	["Text alert"] = "Alerta textual",
	["Displays a message on the screen when you get aggro."] = "Muestra un mensaje en la pantalla cuando tienes aggro.",
	["Only in group"] = "Solo en grupo",
	["Only alert for aggro when you are grouped."] = "Solo alertar de aggro cuando est\195\161s en un grupo",
	["Health frame flash"] = "Destello del marco de salud",
	["Flash the health frame when you get aggro."] = "El marco de salud se ilumina cuando tienes aggro.",
	["Lost aggro"] = "Aggro perdido",
	["Alerts you when you lose aggro."] = "Te avisa cuando pierdes aggro.",

	["Aggro from %s!"] = "\194\161Aggro de %s!",
	["Lost aggro!"] = "\194\161Has perdido aggro!",

	-- oRA2 module
	["Aggro alert"] = "Alerta de aggro",
	["Options for aggro notifications."] = "Opciones para las notificaciones de aggro",
	
	["Display"] = "Mostrar",
	["Set where messages are displayed."] = "Establece d\195\179nde son mostrados los mensajes.",
	
	["Default Frame"] = "Marco por defecto",
	["BigWigs frame"] = "BigWigs",
	["Mik's Scrolling Battle Text"] = "MSBT",
	["Scrolling Combat Text"] = "SCT",
} end)

L:RegisterTranslations("deDE", function() return {
	["Sound alert"] = "Sound Alarm",
	["Plays a sound alert when you get aggro."] = "Spielt einen WarnSound wenn du Aggro bekommst.",
	["Text alert"] = "Text Alarm",
	["Displays a message on the screen when you get aggro."] = "Gibt eine Meldung auf den Bildschirm aus wenn du Aggro bekommst.",
	["Only in group"] = "Nur in Gruppe",
	["Only alert for aggro when you are grouped."] = "Zeigt den Aggro Alarm nur wenn du in einer Gruppe bist.",
	["Health frame flash"] = "Bildschirmrand aufblitzen",
	["Flash the health frame when you get aggro."] = "L\195\164st den Bildschirmrahmen aufblitzen wenn du Aggro bekommst.",
	["Lost aggro"] = "Aggro verlust",
	["Alerts you when you lose aggro."] = "Meldet dir wenn du Aggro verlierst.",
	["None"] = "Keinen",
	["Aggro from %s!"] = "Aggro von %s!",
	["Lost aggro!"] = "Aggro verloren!",

	-- oRA2 module
	["aggroalert"] = "aggroalarm",
	["Participant/AggroAlert"] = "Teilnehmer/AggroAlarm",
	["aggro"] = "aggro",
	["Aggro alert"] = "Aggro Alarm",
	["Options for aggro notifications."] = "Optionen f\195\188r die Aggro Meldung.",
	["Display"] = "Anzeige",
	["Set where messages are displayed."] = "Gibt an wo die Meldungen angezeigt werden.",
	["Default Frame"] = "Standart",
	["BigWigs frame"] = "BigWigs",
	["Mik's Scrolling Battle Text"] = "MSBT",
	["Scrolling Combat Text"] = "SCT",
} end)


-------------------------------------------------------------------------------
-- Addon declaration                                                         --
-------------------------------------------------------------------------------

BanzaiAlert = AceLibrary("AceAddon-2.0"):new("AceConsole-2.0", "AceDB-2.0", "AceEvent-2.0")

local options = {
	type = "group",
	name = L["Aggro alert"],
	desc = L["Options for aggro notifications."],
	handler = BanzaiAlert,
	pass = true,
	get = function(key)
		return BanzaiAlert.db.profile[key]
	end,
	set = function(key, value)
		BanzaiAlert.db.profile[key] = value
		if key == "onlyInGroup" then
			BanzaiAlert:ToggleOnlyInGroup()
		end
	end,
	func = function(key)
		BanzaiAlert:Print("Because of a Dewdrop bug, this option is not available.")
	end,
	args = {
		sound = {
			type = "text",
			name = L["Sound alert"],
			desc = L["Plays a sound alert when you get aggro."],
			validate = {
				["babe"] = "Babe",
				["zenham"] = "Zenham",
				["BellTollAlliance"] = "BellTollAlliance",
				["bell"] = "Bell",
				["none"] = L["None"],
			},
		},
		message = {
			type = "toggle",
			name = L["Text alert"],
			desc = L["Displays a message on the screen when you get aggro."],
		},
		onlyInGroup = {
			type = "toggle",
			name = L["Only in group"],
			desc = L["Only alert for aggro when you are grouped."],
		},
		flash = {
			type = "toggle",
			name = L["Health frame flash"],
			desc = L["Flash the health frame when you get aggro."],
		},
		lost = {
			type = "toggle",
			name = L["Lost aggro"],
			desc = L["Alerts you when you lose aggro."],
		},
		display = {
			type = "text",
			name = L["Display"],
			desc = L["Set where messages are displayed."],
			validate = {
				L["Default Frame"],
				L["BigWigs frame"],
				L["Scrolling Combat Text"],
				L["Mik's Scrolling Battle Text"]
			},
			disabled = function() return BanzaiAlert.db.profile.message ~= true end,
		}
	},
}

-------------------------------------------------------------------------------
-- Initialization                                                            --
-------------------------------------------------------------------------------

local function _InitoRA()
	if oRA and not oRA:HasModule(L["aggroalert"]) then
		local mod = oRA:NewModule(L["aggroalert"])
		mod.participant = true
		mod.name = L["Participant/AggroAlert"]
		mod.consoleCmd = L["aggro"]
		mod.consoleOptions = options
		if not mod.registered then
			oRA:RegisterModule(mod.name, mod)
		end
	end
end

function BanzaiAlert:OnInitialize()
	self:RegisterDB("BanzaiAlertDB")
	self:RegisterDefaults("profile", {
		message = true,
		onlyInGroup = true,
		flash = true,
		lost = false,
		display = L["Default Frame"],
		sound = "babe",
	})
	self:RegisterChatCommand("/banzaialert", "/banzai", options, "BANZAIALERT")
end


function BanzaiAlert:OnEnable()
	lastAggroAlert = nil

	_InitoRA()

	playerName = UnitName("player")

	local found = nil
	for i, val in ipairs(options.args.display.validate) do
		if val == self.db.profile.display then
			found = true
			break
		end
	end

	if not found then
		self.db.profile.display = L["Default Frame"]
	end

	if self.db.profile.onlyInGroup and not UnitExists("party1") then
		if type(aUFBanzai) == "table" and type(aUFBanzai.Disable) == "function" then aUFBanzai:Disable() end
		if type(PitBull_Banzai) == "table" and type(PitBull_Banzai.Disable) == "function" then PitBull_Banzai:Disable() end
	else
		self:RegisterEvent("Banzai_PlayerGainedAggro")
		self:RegisterEvent("Banzai_PlayerLostAggro")
		if type(aUFBanzai) == "table" and type(aUFBanzai.Enable) == "function" then aUFBanzai:Enable() end
		if type(PitBull_Banzai) == "table" and type(PitBull_Banzai.Enable) == "function" then PitBull_Banzai:Enable() end
	end

	self:RegisterEvent("PARTY_MEMBERS_CHANGED", "ToggleOnlyInGroup")
	self:RegisterEvent("ADDON_LOADED")
	self:RegisterEvent("Banzai_Disabled")
end

-------------------------------------------------------------------------------
-- Addon methods                                                             --
-------------------------------------------------------------------------------

function BanzaiAlert:ToggleOnlyInGroup()
	if self.db.profile.onlyInGroup and not UnitExists("party1") then
		if self:IsEventRegistered("Banzai_PlayerGainedAggro") then
			self:UnregisterEvent("Banzai_PlayerGainedAggro")
			self:UnregisterEvent("Banzai_PlayerLostAggro")
			if type(aUFBanzai) == "table" and type(aUFBanzai.Disable) == "function" then aUFBanzai:Disable() end
			if type(PitBull_Banzai) == "table" and type(PitBull_Banzai.Disable) == "function" then PitBull_Banzai:Disable() end
		end	
	elseif not self:IsEventRegistered("Banzai_PlayerGainedAggro") then
		self:RegisterEvent("Banzai_PlayerGainedAggro")
		self:RegisterEvent("Banzai_PlayerLostAggro")
		if type(aUFBanzai) == "table" and type(aUFBanzai.Enable) == "function" then aUFBanzai:Enable() end
		if type(PitBull_Banzai) == "table" and type(PitBull_Banzai.Enable) == "function" then PitBull_Banzai:Enable() end
	end
end

function BanzaiAlert:Alert( gainedAggro, unitId )
	local text = nil
	if gainedAggro then
		text = L["Aggro from %s!"]:format(UnitName(unitId))
	else
		text = L["Lost aggro!"]
	end

	if self.db.profile.display == L["BigWigs frame"] and AceLibrary("AceEvent-2.0"):IsEventRegistered("BigWigs_Message") then -- Big Wigs
		self:TriggerEvent("BigWigs_Message", text, "Red", true, nil)
	elseif self.db.profile.display == L["Scrolling Combat Text"] and SCT then -- SCT 5.x
		SCT_MSG_FRAME:AddMessage(text, 1.0, 0.0, 0.0, 1)
	elseif self.db.profile.display == L["Mik's Scrolling Battle Text"] and MikSBT then -- MSBT
		MikSBT.DisplayMessage(text, MikSBT.DISPLAYTYPE_NOTIFICATION, false, 255, 0, 0)
	elseif CombatText_AddMessage then -- Blizzards FCT
		CombatText_AddMessage(text, COMBAT_TEXT_SCROLL_FUNCTION, 1.0, 0.0, 0.0, "sticky", nil)
	else -- Fallback
		UIErrorsFrame:AddMessage(text, 1.0, 0.0, 0.0, 1, UIERRORS_HOLD_TIME)
	end
end

-------------------------------------------------------------------------------
-- Events                                                                    --
-------------------------------------------------------------------------------

function BanzaiAlert:ADDON_LOADED()
	if arg1 == "oRA2" then
		_InitoRA()
	end
end

function BanzaiAlert:Banzai_PlayerGainedAggro( unitTable )
	if (self.db.profile.onlyInGroup and GetNumPartyMembers() == 0) or not unitTable then
		return
	end

	if not lastAggroAlert or (GetTime() - lastAggroAlert) > 5 then
		if self.db.profile.sound ~= L["None"] and sounds[self.db.profile.sound] then
			local sound = sounds[self.db.profile.sound]
			if sound:find("%\\") then
				PlaySoundFile(sound)
			else
				PlaySound(sound)
			end
		end
		if unitTable[1] then
			if self.db.profile.message then
				self:Alert(true, unitTable[1])
			end
			if self.db.profile.flash and not isFlashing then
				self:StartFlashing()
			end
		end
		lastAggroAlert = GetTime()
	end
end

function BanzaiAlert:Banzai_PlayerLostAggro( unitId )
	if self.db.profile.flash or isFlashing then
		self:StopFlashing()
	end

	if self.db.profile.onlyInGroup and GetNumPartyMembers() == 0 then
		return
	end

	if self.db.profile.lost and self.db.profile.message then
		self:Alert()
	end
end

function BanzaiAlert:Banzai_Disabled()
	self:StopFlashing()
end

-------------------------------------------------------------------------------
-- Frame flashing                                                            --
-------------------------------------------------------------------------------

local function Flash()
	if not banzai:GetUnitAggroByUnitName(playerName) then BanzaiAlert:StopFlashing() end
	UIFrameFlash(LowHealthFrame, 0.2, 0.8, 10, nil, .5, 0)
end

function BanzaiAlert:StartFlashing()
	if self:IsEventScheduled("banzaiflash") or isFlashing then return end
	UIFrameFlash(LowHealthFrame, 0.2, 0.8, 10, nil, .5, 0)
	self:ScheduleRepeatingEvent("banzaiflash", Flash, .5)
	isFlashing = true
end

function BanzaiAlert:StopFlashing()
	if not isFlashing then return end

	if self:IsEventScheduled("banzaiflash") then
		self:CancelScheduledEvent("banzaiflash")
	end
	UIFrameFlashRemoveFrame(LowHealthFrame)
	UIFrameFadeRemoveFrame(LowHealthFrame)
	UIFrameFadeOut(LowHealthFrame, 0.5, LowHealthFrame:GetAlpha(), 0)
	isFlashing = nil
end

